Bug 1650954 - alpine receives self-signed certificate from Gmail using TLS 1.3
Summary: alpine receives self-signed certificate from Gmail using TLS 1.3
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: alpine
Version: 29
Hardware: Unspecified
OS: Unspecified
unspecified
medium
Target Milestone: ---
Assignee: Joshua Daniel Franklin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-11-18 01:45 UTC by Jargon Scott
Modified: 2020-07-09 15:55 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2019-11-27 23:37:22 UTC
Type: Bug


Attachments (Terms of Use)

Description Jargon Scott 2018-11-18 01:45:25 UTC
alpine receives self-signed certificate from Gmail using TLS 1.3

Starting with Fedora 29, alpine receives an (intentionally) bogus certificate from imap.gmail.com .  The subject of this certificate is:

"No SNI provided; please fix your client."

Judging from other bug reports ([1], [2]), alpine is likely suffering the same fate as certain other mail clients that (a) speak TLS 1.3 and (b) do so without sending a hostname in a TLS Server Name Indication (SNI) extension.

Starting about August 2018, it appears that Google has chosen to send this special-purpose "fix your stuff" certificate to clients like alpine, ones that are new enough to have their transport layer protected with TLS 1.3, but that aren't sending a target hostname in a TLS SNI extension.

Indeed, upon inspection of dumped alpine traffic to imap.google.com , we can confirm that:

- on *both* F28 and F29, alpine does *not* send a TLS SNI extension in its Client Hello

- on F28, alpine's connections with the "/tls" parameter speak TLS 1.2, and Google sends a real certificate

- on F29, the same alpine configuration produces a TLS 1.3 connection, to which Google sends a bogus certificate

REQUEST FOR ENGINEERING: Please patch the alpine mail client to send a TLS SNI extension on encrypted IMAP connections.

For implementation, it seems reasonable to blindly copy the target server's hostname into the SNI field (although it wouldn't hurt to be able to specify the value for this field too).

Justification for this RFE can be found in the below-listed bugs, which needed the same work when Google implemented their policy.

Besides, enabling TLS SNI is preferable over less-secure options like asking users to stick with an older version of TLS or enabling the "/novalidate-cert" parameter.

[1] https://bugzilla.redhat.com/show_bug.cgi?id=1611815

[2] https://bugzilla.redhat.com/show_bug.cgi?id=1629151

Comment 1 Matt McHenry 2019-10-29 11:40:33 UTC
This commit appears to be a fix, though I haven't tested it yet:

https://repo.or.cz/alpine.git/commit/08fcd1b86979b422eb586e56459d6fe15333e500

Comment 2 Ben Cotton 2019-10-31 18:43:15 UTC
This message is a reminder that Fedora 29 is nearing its end of life.
Fedora will stop maintaining and issuing updates for Fedora 29 on 2019-11-26.
It is Fedora's policy to close all bug reports from releases that are no longer
maintained. At that time this bug will be closed as EOL if it remains open with a
Fedora 'version' of '29'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 29 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 3 Ben Cotton 2019-11-27 23:37:22 UTC
Fedora 29 changed to end-of-life (EOL) status on 2019-11-26. Fedora 29 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 4 Jargon Scott 2020-07-09 15:55:31 UTC
This bug is long closed, but just noticed that this is resolved in Fedora 32 in alpine-2.23-2.fc32.x86_64 .


Note You need to log in before you can comment on or make changes to this bug.